package br.com.barcodetest;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.widget.TextView;

import java.io.InputStream;
import java.nio.ByteBuffer;

import Softek.Barcode;

public class MainActivity extends AppCompatActivity {
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		TextView info = (TextView) findViewById(R.id.act_main_info);

		Barcode barcode = new Barcode();
		barcode.LicenseKey = "";

		barcode.MultipleRead = 1;


		InputStream is = this.getResources().openRawResource(R.raw.barcodes);
		Bitmap installment = BitmapFactory.decodeStream(is);

		int bytes = installment.getByteCount();
		ByteBuffer buffer = ByteBuffer.allocate(bytes);
		installment.copyPixelsToBuffer(buffer); //Move the byte data to the buffer

		byte[] data = buffer.array(); //Get the bytes array of the bitmap

		int n = barcode.ScanBarCodeFromRGBABitmap(installment.getWidth(), installment.getHeight(), data);
		if(n > 0) {
			String output = "Found " + n + " barcodes\r\n";
			for (int i = 1; i <= n; i++) {
				output += barcode.GetBarString(i) + " (" + barcode.GetBarStringType(i) + ")\r\n";
			}
			info.setText(output);
		} else {
			// Return value of 0 means no barcodes and < 0 is error
			info.setText("No barcodes found");
		}
	}
}
