package com.softeksoftware.bardecoder;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.os.Environment;
import android.graphics.ImageFormat;
import android.graphics.Rect;
import android.graphics.YuvImage;
import java.io.ByteArrayOutputStream;
import android.hardware.Camera;
import android.hardware.Camera.PreviewCallback;
import android.os.Bundle;
import android.view.Menu;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.view.ViewGroup.LayoutParams;
import android.os.Vibrator;
import android.preference.PreferenceManager;
import android.media.MediaPlayer;
import android.view.MenuItem;


public class scanner extends Activity {
	private boolean haveFinished;
	private Preview mPreview ;
	private DrawOnTop mDrawOnTop;
	private String extrasBaseName;
	private String resultsBaseName ;
	public String licenseKey;
	public String settings ;
	public String defaultSettings;
	private boolean finishOnSuccess ;
	public boolean useTorch;
	public boolean vibrateOnSuccess;
	public boolean beepOnSuccess ;
	public boolean standAloneMode = true ;
	public int minimumWidth = 100;
    public boolean isInFront = true;

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        settings = "";
        defaultSettings = "";
        finishOnSuccess = false ;
        haveFinished = false;
        vibrateOnSuccess = true ;
        beepOnSuccess = true ;
        licenseKey = "MY LICENSE KEY";
        loadDefaultSettings();
        extrasBaseName = "com.softeksoftware.bardecoder.scanner.";
        resultsBaseName = "com.softeksoftware.bardecoder.Result.";
        processIntent();
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        mDrawOnTop = new DrawOnTop(this);
        mPreview = new Preview(this, this, mDrawOnTop);
       	setContentView(mPreview);
        addContentView(mDrawOnTop, new LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
    }

    @Override
	public boolean onCreateOptionsMenu(Menu menu) {
    	if (standAloneMode)
    	{
    		MenuItem item = menu.add("Options");
    		item.setIntent(new Intent(this, Prefs.class));
    	}
        return super.onCreateOptionsMenu(menu);
	}

	@Override
    protected void onResume() {
       isInFront = true;
       mPreview.getPrefSettings();
       super.onResume();
    }

    @Override
       protected void onPause() {
        isInFront = false;
    	super.onPause();
    } 
    
    public String GetPrefString(Context context, final String key) {
        SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(context);
        return pref.getString(key, "");
    }    
 
    public boolean GetPrefBoolean(Context context, final String key, final boolean defaultValue) {
        SharedPreferences settings = PreferenceManager.getDefaultSharedPreferences(context);
        return settings.getBoolean(key, defaultValue);
    }    

    public int GetPrefBooleanAsInt(Context context, final String key, final boolean defaultValue) {
        SharedPreferences settings = PreferenceManager.getDefaultSharedPreferences(context);
        if (settings.getBoolean(key, defaultValue))
        {
        	return 1 ;
        }
        else
        {
        	return 0 ;
        }
    }   
    
    public int GetPrefInteger(Context context, final String key, final int defaultValue) {
        SharedPreferences settings = PreferenceManager.getDefaultSharedPreferences(context);
        return settings.getInt(key, defaultValue);
    }    
    
    public void processIntent()
    {
        Intent i = this.getIntent();
        if (i == null)
        	return ;
        
        Bundle b = i.getExtras();
        if (b == null)
        	return ;
        
        standAloneMode = false ;
        
        settings = b.getString(extrasBaseName + "settings");
        if (settings == null)
        	settings = "";
        
        finishOnSuccess = b.getBoolean(extrasBaseName + "finishOnSuccess", false);
        vibrateOnSuccess = b.getBoolean(extrasBaseName + "vibrateOnSuccess", false);
        beepOnSuccess = b.getBoolean(extrasBaseName + "beepOnSuccess", false);
        useTorch = b.getBoolean(extrasBaseName + "useTorch", false);
        minimumWidth = b.getInt(extrasBaseName + "minimumWidth", 100);
        if (finishOnSuccess)
            licenseKey = "";
        
        String clientLicenseKey = b.getString(extrasBaseName + "licenseKey");
        if (clientLicenseKey != null)
        	licenseKey = clientLicenseKey;
        
    }
    
    public void playBeep()
    {
    	int id = 1 ;
		int[] resId = new int[] {0, R.raw.bloop, R.raw.bliptyblop, R.raw.tadah} ;
    	
		// Get noise from preferences if stand-alone else use beepOnSuccess
    	if (standAloneMode)
    	{
    		String strId = GetPrefString(this, "pref_noise");
    		try
    		{
    			id = Integer.parseInt(strId);
    		}
    		catch(NumberFormatException ex)
    		{
    			id = 1 ;
    		}
    	
    		if (id >= resId.length)
    		{
    			id = 1 ;
    		}
    		
    		if (id < 0)
    		{
    			id = 1 ;
    		}
    		id = 1 ;
    	}
    	else
    	{
    		if (beepOnSuccess)
    		{
    			id = 1 ;
    		}
    		else
    		{
    			id = 0 ;
    		}
    	}
    	
    	if (id > 0)
    	{
    		try {
     			MediaPlayer mp = MediaPlayer.create(this, resId[id]);
    	
    			mp.start();
    			
    			Thread.sleep(300, 0);
    		}
    		catch (InterruptedException ex)
    		{
    			;
    		}
    		
    		catch (RuntimeException ex)
    		{
    			;
    		}
    	}
    }  
    
    public void vibrate()
    {
    	if (standAloneMode)
    	{
    		vibrateOnSuccess = GetPrefBoolean(this, "pref_vibrate", true);
    	}
    	
    	if (vibrateOnSuccess)
    	{
    		Vibrator v = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);
    		v.vibrate(100);
    	}
    }
    
    public void scanComplete(String value, String type)
    {
    	if (haveFinished)
    		return ;
    	
    	vibrate();
    	playBeep() ;
 
        Intent rIntent = new Intent();
        rIntent.putExtra("com.softeksoftware.bardecoder.scanner.value", value);
        rIntent.putExtra("com.softeksoftware.bardecoder.scanner.type", type);
        setResult(RESULT_OK, rIntent) ;
        
		  
        if (finishOnSuccess)
        {
        	haveFinished = true ;
        	finish();
        }
        else
        {
            Intent resultActivity = new Intent(this, Result.class);
            resultActivity.putExtra(resultsBaseName + "value", value);
            resultActivity.putExtra(resultsBaseName + "type", type);
            startActivityForResult(resultActivity, 0);        
        }
    }
    
    public void loadDefaultSettings()
    {
    	InputStream is = this.getResources().openRawResource(R.raw.settings);
        BufferedReader br = new BufferedReader(new InputStreamReader(is));
        String readLine = null;
        defaultSettings = "";

        try {
            while ((readLine = br.readLine()) != null) {
            	defaultSettings += readLine;
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}

// Draw stuff on top of the camera preview
class DrawOnTop extends View {
	boolean mInitialised;
	Paint mPaintFade ;
	Paint mPaintBlack;
	Paint mPaintYellow;
	Paint mPaintYellowFade;
	Paint mPaintRed;
	Paint mPaintGreen;
	Paint mPaintBlue;
	Paint mPaintWhite;
	public Rect mScanRect ;

    public DrawOnTop(Context context) {
        super(context);
       
        mInitialised = false;
        
        mPaintBlack = new Paint();
        mPaintBlack.setStyle(Paint.Style.FILL);
        mPaintBlack.setColor(Color.BLACK);
        mPaintBlack.setTextSize(25);
 
        mPaintFade = new Paint();
        mPaintFade.setStyle(Paint.Style.FILL);
        mPaintFade.setColor(Color.BLACK);
        mPaintFade.setTextSize(25);
        mPaintFade.setAlpha(100);
       
        
        mPaintYellow = new Paint();
        mPaintYellow.setStyle(Paint.Style.FILL);
        mPaintYellow.setColor(Color.YELLOW);
        mPaintYellow.setTextSize(25);

        mPaintYellowFade = new Paint();
        mPaintYellowFade.setStyle(Paint.Style.FILL);
        mPaintYellowFade.setColor(Color.YELLOW);
        mPaintYellowFade.setTextSize(25);
        mPaintYellowFade.setAlpha(150);
        
        
        mPaintRed = new Paint();
        mPaintRed.setStyle(Paint.Style.FILL);
        mPaintRed.setColor(Color.RED);
        mPaintRed.setTextSize(25);
        
        mPaintGreen = new Paint();
        mPaintGreen.setStyle(Paint.Style.FILL);
        mPaintGreen.setColor(Color.GREEN);
        mPaintGreen.setTextSize(25);
        
        mPaintBlue = new Paint();
        mPaintBlue.setStyle(Paint.Style.FILL);
        mPaintBlue.setColor(Color.BLUE);
        mPaintBlue.setTextSize(25);
 
        mPaintWhite = new Paint();
        mPaintWhite.setStyle(Paint.Style.FILL);
        mPaintWhite.setColor(Color.WHITE);
        mPaintWhite.setTextSize(25);
    }

    @Override
    protected void onDraw(Canvas canvas) {
        if (mInitialised)
        {
        	int left, top, right, bottom ;
        	left = (mScanRect.left * canvas.getWidth()) / 100;
        	right = (mScanRect.right * canvas.getWidth()) / 100;
        	top = (mScanRect.top * canvas.getHeight()) / 100;
        	bottom = (mScanRect.bottom * canvas.getHeight()) / 100;

        	canvas.drawRect(0, 0, canvas.getWidth(), top, mPaintFade);
        	canvas.drawRect(0, bottom, canvas.getWidth(), canvas.getHeight(), mPaintFade);
        	canvas.drawRect(0, top, left, bottom, mPaintFade);
        	canvas.drawRect(right, top, canvas.getWidth(), bottom, mPaintFade);

        	canvas.drawLine(left, (top + bottom) / 2, right, (top + bottom) / 2, mPaintRed);
        	
        	canvas.drawLine(left, top, right, top, mPaintWhite);
        	canvas.drawLine(left, bottom, right, bottom, mPaintWhite);
        	canvas.drawLine(left, top, left, bottom, mPaintWhite);
        	canvas.drawLine(right, top, right, bottom, mPaintWhite);
        } // end if statement
        
        super.onDraw(canvas);
        
    } // end onDraw method
}

// Display the camera preview and scan bitmap for barcodes
class Preview extends SurfaceView implements SurfaceHolder.Callback {
    SurfaceHolder mHolder;
    Camera mCamera;
    scanner mScanner;
    boolean mFinished;
    boolean m2dBarcode;
    DrawOnTop mDrawOnTop;
    Softek.Barcode mBarcode = null;
    int mFocusCount;
    boolean mInitialised;
    int skipFrames = 0 ;
    boolean mBusy = false;

    Preview(scanner s, Context context, DrawOnTop drawOnTop) {
        super(context);
        
        mDrawOnTop = drawOnTop;
        mFinished = false;
        mInitialised = false ;
        mFocusCount = 0 ;
        mScanner = s;
        
	    mBarcode = new Softek.Barcode();

	    // default settings are loaded first, then settings from preferences (if stand-alone) and then settings from the calling app (if there is one)
	    if (mScanner.defaultSettings != null)
	    	mBarcode.LoadXMLSettings(mScanner.defaultSettings);
	    
	    getPrefSettings() ;

	    if (mScanner.settings != null)
	    	mBarcode.LoadXMLSettings(mScanner.settings);
	    
	    mBarcode.LicenseKey = mScanner.licenseKey;
	    
    
        // Install a SurfaceHolder.Callback so we get notified when the
        // underlying surface is created and destroyed.
        mHolder = getHolder();
        mHolder.addCallback(this);
        mHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
    }
    
    public void getPrefSettings()
    {
    	if ((mScanner.standAloneMode == false) || (mBarcode == null))
    	{
    		return ;
    	}
    	
    	mBarcode.ReadQRCode = mScanner.GetPrefBooleanAsInt(mScanner, "pref_qrcode", true);
    	mBarcode.ReadDataMatrix = mScanner.GetPrefBooleanAsInt(mScanner, "pref_datamatrix", true);
    	mBarcode.ReadPDF417 = mScanner.GetPrefBooleanAsInt(mScanner, "pref_pdf417", true);
    	mBarcode.ReadEAN13 = mBarcode.ReadEAN8 = mBarcode.ReadUPCA = mBarcode.ReadUPCE = mScanner.GetPrefBooleanAsInt(mScanner, "pref_ean", true);
    	mBarcode.ReadDatabar = mScanner.GetPrefBooleanAsInt(mScanner, "pref_databar", true);
    	mBarcode.ReadCode39 = mScanner.GetPrefBooleanAsInt(mScanner, "pref_code39", true);
    	mBarcode.ReadCode128 = mScanner.GetPrefBooleanAsInt(mScanner, "pref_code128", true);
    	mBarcode.ReadCode25 = mScanner.GetPrefBooleanAsInt(mScanner, "pref_code25", true);
    	mBarcode.ReadCode25ni = mScanner.GetPrefBooleanAsInt(mScanner, "pref_datalogic", true);
    }
    
    public void surfaceCreated(SurfaceHolder holder) {
        mCamera = Camera.open();
         
        try {
           mCamera.setPreviewDisplay(holder);
           
           // Preview callback used whenever new viewfinder frame is available
           mCamera.setPreviewCallback(new PreviewCallback() {
        	  public void onPreviewFrame(byte[] data, Camera camera)
        	  {
        		  if (mScanner.isInFront == false)
        			  return ;
        		  
           		  if (mBusy)
        			  return ;
           		  
           		  mBusy = true ;
 
           		  if (skipFrames > 0)
        		  {
        			  skipFrames--;
        			  mBusy = false ;
        			  return ;
        		  }
        		  
        		  
        		  Camera.Parameters params = camera.getParameters();
        		  
        		  if (! mInitialised)
        		  {
        			  // Initialize the draw-on-top companion
        			  mDrawOnTop.mInitialised = true ;
        			  if ((mBarcode.ReadDataMatrix == 0) && (mBarcode.ReadPDF417 == 0) && (mBarcode.ReadDatabar == 0) && (mBarcode.ReadQRCode == 0))
        			  {
        				  mBarcode.ScanDirection = 5;
        			  }
          			  mDrawOnTop.mScanRect = new Rect(15,10,85,90);
          			  //mBarcode.SetScanRect(mDrawOnTop.mScanRect.left, mDrawOnTop.mScanRect.top, mDrawOnTop.mScanRect.right, mDrawOnTop.mScanRect.bottom, 1);
        			  mInitialised = true ;
         		  }






                  //if (mBarcode.ScanBarCodeFromBitmap(params.getPreviewSize().width, params.getPreviewSize().height, data) > 0)
                  if (mBarcode.ScanBarCodeFromBitmap(params.getPreviewSize().width, params.getPreviewSize().height, data) > 0)
        		  {
        			  m2dBarcode = false ;
        			  
	    			  if (mBarcode.GetBarStringType(1).equals("DATAMATRIX"))
	    				  m2dBarcode = true ;
	    			  
	    			  if (mBarcode.GetBarStringType(1).equals("PDF417"))
	    				  m2dBarcode = true ;
	
	    			  if (mBarcode.GetBarStringType(1).equals("QRCODE"))
	    				  m2dBarcode = true ;
    			  
    				  if (m2dBarcode | (mBarcode.GetBarStringWidth(1) >= mScanner.minimumWidth) | (mBarcode.GetBarStringHeight(1) >= mScanner.minimumWidth))
    				  {
    					  skipFrames = 10;
    					  mFocusCount = 0 ;
    					  mScanner.scanComplete(mBarcode.GetBarString(1), mBarcode.GetBarStringType(1));
    				  }
        			  
        		  }
        		  else
        		  {
        			  skipFrames = 1 ;
        			  if (mFocusCount++ > 20)
        			  {
        				  mCamera.autoFocus(null);
        				  mFocusCount = 0 ;
        			  }
        		  }
       			  mDrawOnTop.invalidate();
       			  mBusy = false ;
         	  }
           });
        } 
        catch (IOException exception) {
            mCamera.release();
            mCamera = null;
        }
    }
    
    // Function that saves frame to jpg file

    public boolean saveFrame(byte[] data, int width, int height, int quality, int frameCount)
    {
 			  YuvImage im = new YuvImage(data, ImageFormat.NV21, width,
					  height, null);
			  
			  Rect r = new Rect(0,0,width,height);

			  ByteArrayOutputStream baos = new ByteArrayOutputStream();
			  im.compressToJpeg(r, quality, baos);


			  try{
				  String fileName ;
				  
				  fileName = String.format("/mnt/sdcard/qrcode/noread%d.dat", frameCount) ;
				  //mBarcode.SaveData(width, height, data, fileName);
				  
				  fileName = String.format("qrcode/noread%d.jpg", frameCount) ;
				  
				  File root = Environment.getExternalStorageDirectory();
				  FileOutputStream output = new FileOutputStream(new File(root, fileName));
				  output.write(baos.toByteArray());
				  output.flush();
				  output.close();
				  
				  im = null ;
				  baos = null ;
				  
				  return true ;

			  }
			  
			  catch(FileNotFoundException e){
				  im = null ;
				  baos = null ;
       			  return false ;
			  }
			  
			  catch(IOException e){
				  im = null ;
				  baos = null ;
       			  return false;
			  }   
    }

    public void surfaceDestroyed(SurfaceHolder holder) {
        // Surface will be destroyed when we return, so stop the preview.
        // Because the CameraDevice object is not a shared resource, it's very
        // important to release it when the activity is paused.
    	mFinished = true;
    	mCamera.setPreviewCallback(null);
        mCamera.stopPreview();
        mCamera.release();
        mCamera = null;
    }

    public void surfaceChanged(SurfaceHolder holder, int format, int w, int h) {
        // Now that the size is known, set up the camera parameters and begin
        // the preview.
        //mCamera.startPreview();

        Camera.Parameters parameters = mCamera.getParameters();
        /*
        parameters.setPreviewSize(480, 320);
        */
        parameters.setPreviewFrameRate(10);
        //parameters.setSceneMode(Camera.Parameters.SCENE_MODE_BARCODE);

        parameters.setFocusMode(Camera.Parameters.FOCUS_MODE_AUTO);
        if (mScanner.useTorch)
        	parameters.setFlashMode(Camera.Parameters.FLASH_MODE_TORCH);
        
         //parameters.setFocusMode(Camera.Parameters.FOCUS_MODE_MACRO);

               mCamera.setParameters(parameters);
        mCamera.startPreview();

      }
}
